/*2:*/
#line 58 "valve.w"

#define REVDATE "16th December 2004" \

#define TRUE 1
#define FALSE 0 \


#line 59 "valve.w"


/*12:*/
#line 294 "valve.w"

#include "config.h"  
#include "getopt.h"     

/*:12*/
#line 61 "valve.w"

/*13:*/
#line 303 "valve.w"

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#include <time.h> 
#include <math.h> 
#include <sys/time.h> 
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#ifdef HAVE_STRING_H
#include <string.h> 
#else
#ifdef HAVE_STRINGS_H
#include <strings.h> 
#endif
#endif

/*:13*//*14:*/
#line 332 "valve.w"

#ifdef HAVE_NANOSLEEP
#define NANOSLEEP nanosleep
#define TIMESPEC timespec
#define TIMER "nanosleep"
#else
#define NANOSLEEP em_nanosleep
#define TIMESPEC em_timespec
struct em_timespec{
time_t tv_sec;
long tv_nsec;
};
#define EMULATE_NANOSLEEP
#ifdef HAVE_USLEEP
#define USLEEP usleep
#define TIMER "usleep"
#else
#define EMULATE_USLEEP
#define TIMER "setitimer"
#include <sys/signal.h> 
#define USLEEP em_usleep
#endif
#endif

/*:14*/
#line 62 "valve.w"

/*15:*/
#line 361 "valve.w"

#ifdef _WIN32
#define FORCE_BINARY_IO
#include <io.h> 
#include <fcntl.h> 
#endif

#ifdef HAVE_CYGWIN
#define FORCE_BINARY_IO
#include <io.h>                 
#include <fcntl.h> 
#endif

/*:15*/
#line 63 "valve.w"

/*16:*/
#line 379 "valve.w"

typedef unsigned char byte;

static FILE*fi;
static FILE*fo;

static int fdi,fdo;

static int verbose= FALSE;
static int measure= FALSE;
static int showtrans= FALSE;

#ifndef MIN_SLEEP_NSEC
#define MIN_SLEEP_NSEC 10000000      
#endif
static unsigned long min_sleep_nsec= MIN_SLEEP_NSEC;

static int always_wait= FALSE;


/*:16*//*19:*/
#line 434 "valve.w"

static const struct option long_options[]= {
{"alwayswait",0,NULL,'a'},
{"blocksize",1,NULL,'b'},
{"copyright",0,NULL,'c'},
{"help",0,NULL,'u'},
{"measure",0,NULL,'m'},
{"rate",1,NULL,'r'},
{"summary",0,NULL,'s'},
{"timingtest",1,NULL,202},
{"verbose",0,NULL,'v'},
{"version",0,NULL,201},
{"waitmin",1,NULL,'w'},
{0,0,0,0}
};
static const char single_letter_options[]= "ab:chr:suvw:";
static int option_index= 0;

/*:19*/
#line 64 "valve.w"

/*23:*/
#line 632 "valve.w"


/*18:*/
#line 404 "valve.w"

static void usage(void)
{

printf("%s  --  Copy data, enforcing bandwidth limit.  Call:\n",PRODUCT);
printf("           %s [options] [infile] [outfile]\n",PRODUCT);
printf("\n");
printf("Options:\n");
printf("           -a, --alwayswait    Always wait between blocks, regardless"
" of transfer rate\n");
printf("           -b, --blocksize n   Copy blocks of n bytes\n");
printf("           --copyright         Print copyright information\n");
printf("           -m, --measure       Measure transfer rate only (no limitation)\n");
printf("           -r, --rate n        Limit transfer rate to n bytes/second\n");
printf("           -s, --summary       Print actual transfer rate\n");
printf("           --timingtest n      Run minimum wait timing test for n seconds\n");
printf("           -u, --help          Print this message\n");
printf("           -v, --verbose       Verbose: print transfer rate statistics\n");
printf("           --version           Print version number\n");
printf("           --waitmin n         Set minimum wait time to n nanoseconds\n");
printf("\n");
printf("by John Walker\n");
printf("http://www.fourmilab.ch/\n");
}

/*:18*/
#line 634 "valve.w"
;
/*27:*/
#line 755 "valve.w"

static double sizearg(const char*arghhh){
char*arg= malloc(strlen(arghhh)+1);
int decimalPower= FALSE;
static char SIpowers[]= "KMGTPEZY";
static char legacyPowers[]= "cwb";
static int legacyFactors[]= {1,2,512};
char*a;
const char*s;
double count,factor= 1.0;

if(arg==NULL){
fprintf(stderr,"Unable to allocate argument parsing buffer.\n");
exit(1);
}

a= arg;
s= arghhh;


while(1){
char c= *s++;
if(c!=','){
*a++= c;
}
if(c==0){
break;
}
};



a-= 2;
if((a> arg)&&((*a=='B')||(*a=='D'))){
decimalPower= TRUE;
a--;
}
if((a> arg)&&(!isdigit(*a))){
if(*a=='k'){
*a= 'K';
}

if((s= strchr(SIpowers,*a))!=NULL){
int p= (s-SIpowers)+1;
*a= 0;
factor= decimalPower?pow(10.0,3.0*p):pow(2.0,10.0*p);
}else if((s= strchr(legacyPowers,*a))!=NULL){
*a= 0;
factor= legacyFactors[s-legacyPowers];
}else{
fprintf(stderr,"Unknown factor suffix '%c' in size argument \"%s\".\n",*a,arghhh);
exit(2);
}
}



count= strtod(arg,&a);
if(*a!=0){
fprintf(stderr,"Numeric syntax error in size argument \"%s\".\n",arghhh);
exit(2);
}
return count*factor;
}

/*:27*/
#line 635 "valve.w"
;
/*24:*/
#line 650 "valve.w"

static char*commas(const double f){
#define StringBufLength 96
static char res[8][StringBufLength];
static int nr= 0;
static char s[StringBufLength];

int i;
char*p= res[nr];
char*e= p+(StringBufLength-1);
int l;

nr= (nr+1)%8;
*e= 0;
i= snprintf(s,StringBufLength,"%.0f",f);
if((i<0)||(i>=StringBufLength)){
return"*Truncated*";
}
l= strlen(s)-1;
for(i= l;i>=0;i--){
if((i<l)&&(((l-i)%3)==0)){
*--e= ',';
}
*--e= s[i];
}
return e;
}

/*:24*/
#line 636 "valve.w"
;
/*30:*/
#line 872 "valve.w"

#ifdef EMULATE_USLEEP

#ifndef HAVE_SETITIMER
error error error System has neither nanosleep,usleep,nor setitimer
#endif

static int volatile waiting;
static RETSIGTYPE(*oldsig)();

static RETSIGTYPE getalrm(int i)
{
waiting= 0;
signal(SIGALRM,getalrm);
}

void em_usleep(unsigned long t)
{
static struct itimerval it,ot;

it.it_value.tv_sec= t/1000000;
it.it_value.tv_usec= t%1000000;
oldsig= signal(SIGALRM,getalrm);
waiting= 1;
if(setitimer(ITIMER_REAL,&it,&ot)){
return;
}
while(waiting){
pause();
}
signal(SIGALRM,oldsig);
}
#endif

/*:30*/
#line 637 "valve.w"
;
/*29:*/
#line 845 "valve.w"


#ifdef EMULATE_NANOSLEEP

void em_nanosleep(const struct em_timespec*req,struct em_timespec*rem)
{
double usecs= (req->tv_sec*1e6)+(req->tv_nsec/1000);
time_t slsec;
unsigned long slusec;

if(usecs<1){
usecs= 1;
}
slsec= (time_t)(usecs/1e6);
slusec= (unsigned long)(usecs-(slsec*1000000));
if(slsec> 0){
sleep(slsec);
}
USLEEP(slusec);
}
#endif

/*:29*/
#line 638 "valve.w"
;
/*25:*/
#line 684 "valve.w"

static void timingtest(const int nsec){
int s= nsec;
time_t t= time(NULL);
int i;
struct TIMESPEC nsi,nso;
unsigned long n= 0;

printf("Using minimum wait time (--waitmin) = %s nanoseconds\n",
commas((double)min_sleep_nsec));
if(s<=0){
printf("Invalid timing test duration.  Using 60 seconds.\n");
s= 60;
}
printf("Running "TIMER" timing test for %d seconds.\n",nsec);

nsi.tv_sec= 0;
nsi.tv_nsec= 1;

while((time(NULL)-t)<s){
for(i= 0;i<500;i++){
NANOSLEEP(&nsi,&nso);
n++;
}
}

printf("Minimum nanosleep() time: %s nsec.\n",
commas(((time(NULL)-t)*1E9)/n));
}

/*:25*/
#line 639 "valve.w"
;

/*:23*/
#line 65 "valve.w"

/*3:*/
#line 75 "valve.w"

int main(int argc,char*argv[])
{

/*10:*/
#line 265 "valve.w"

int f,opt;
#ifdef FORCE_BINARY_IO
int in_std= TRUE,out_std= TRUE;
#endif

double nbytes= 0;
unsigned int blocksize;

double transferRate= 1e6;
double blockSize= -1;

struct timeval tstart,tend;
struct timezone tz;
byte*iobuf;
unsigned int lr,lw;
double duration,secblocks,estsleep;

struct TIMESPEC nts,ntsrem;

long nblocks,nnomsec;


/*:10*/
#line 79 "valve.w"
;

/*20:*/
#line 460 "valve.w"


while((opt= my_getopt_long(argc,argv,single_letter_options,
long_options,&option_index))!=-1){

switch(opt){



case'a':
always_wait= TRUE;
break;

case'b':
blockSize= sizearg(my_optarg);
break;

case'c':
printf("This program is in the public domain.\n");
return 0;

case'm':
showtrans= measure= TRUE;
break;

case'r':

transferRate= sizearg(my_optarg);
break;

case's':
showtrans= TRUE;
break;

case 202:
timingtest(atoi(my_optarg));
return 0;

case'u':
case'?':
usage();
return 0;

case'v':
showtrans= verbose= TRUE;
break;

case 201:
/*26:*/
#line 718 "valve.w"

printf("%s %s\n",PRODUCT,VERSION);
printf("Last revised: %s\n",REVDATE);
printf("The latest version is always available\n");
printf("at http://www.fourmilab.ch/webtools/valve/\n");

/*:26*/
#line 508 "valve.w"
;
return 0;

case'w':
{double d= sizearg(my_optarg);
if((d<0)||(d>=pow(2,32))){
fprintf(stderr,
"Invalid --waitmin value \"%s\".  Must be >= 0 and < 2^32.\n",my_optarg);
return 2;
}
min_sleep_nsec= (unsigned long)d;
}
break;

default:
fprintf(stderr,"***Internal error: unhandled case %d in option processing.\n",
opt);
return 1;
}
}

/*:20*/
#line 81 "valve.w"
;
/*21:*/
#line 533 "valve.w"


if(transferRate<=0){
fprintf(stderr,
"Transfer rate specification (%.0f bytes/sec) invalid.  Must be >= 1.\n",
transferRate);
return 2;
}
if(blockSize==-1){
blockSize= transferRate/4;
if(blockSize> (1<<20)){
blockSize= 1<<20;
}
}
if(blockSize<1){
fprintf(stderr,"Block size specification (%.0f bytes) invalid.  Must be >= 1.\n",blockSize);
return 2;
}
blocksize= (unsigned int)(blockSize+0.5);

/*:21*/
#line 82 "valve.w"
;
/*22:*/
#line 565 "valve.w"






fi= stdin;
fo= stdout;

f= 0;
for(;my_optind<argc;my_optind++){
char*cp= argv[my_optind];
switch(f){

case 0:
if(strcmp(cp,"-")!=0){
if((fi= fopen(cp,
#ifdef FORCE_BINARY_IO
"rb"
#else
"r"
#endif
))==NULL){

fprintf(stderr,"Cannot open input file %s\n",cp);
return 2;
}
#ifdef FORCE_BINARY_IO
in_std= FALSE;
#endif
}
f++;
break;

case 1:
if(strcmp(cp,"-")!=0){
if((fo= fopen(cp,
#ifdef FORCE_BINARY_IO
"wb"
#else
"w"
#endif
))==NULL){

fprintf(stderr,"Cannot open output file %s\n",cp);
return 2;
}
#ifdef FORCE_BINARY_IO
out_std= FALSE;
#endif
}
f++;
break;

default:

fprintf(stderr,"Too many file names specified.\n");
usage();
return 2;
}
}

/*:22*/
#line 83 "valve.w"
;
/*8:*/
#line 221 "valve.w"

#ifdef FORCE_BINARY_IO
if(in_std){
#ifdef _WIN32
_setmode(_fileno(fi),O_BINARY);
#endif
#ifdef HAVE_CYGWIN
setmode(_fileno(fi),O_BINARY);
#endif
}
if(out_std){
#ifdef _WIN32
_setmode(_fileno(fo),O_BINARY);
#endif
#ifdef HAVE_CYGWIN
setmode(_fileno(fo),O_BINARY);
#endif
}
#endif

/*:8*/
#line 84 "valve.w"
;

/*9:*/
#line 252 "valve.w"

fdi= fileno(fi);
fdo= fileno(fo);

iobuf= malloc(blocksize);
if(iobuf==NULL){
fprintf(stderr,"Unable to allocate %u byte I/O buffer.\n",blocksize);
return 1;
}

/*:9*/
#line 86 "valve.w"
;

/*4:*/
#line 108 "valve.w"

secblocks= transferRate/blocksize;
estsleep= 1e9/(transferRate/blocksize);

nts.tv_sec= (time_t)(estsleep/1e9);
nts.tv_nsec= (long)(estsleep-nts.tv_sec);
nblocks= 0;
nnomsec= 0;
if(verbose){
fprintf(stderr,"I/O block size: %s bytes.\n",commas((double)blocksize));
if(!measure){
fprintf(stderr,"Requested transfer rate: %s bytes/second.\n",commas(transferRate));
fprintf(stderr,"Blocks per second: %.0f  Initial sleep time estimate: %.0f nsec\n",
secblocks,estsleep);
}
}

/*:4*/
#line 88 "valve.w"
;

/*5:*/
#line 134 "valve.w"

gettimeofday(&tstart,&tz);
while((lr= read(fdi,iobuf,blocksize))> 0){
lw= write(fdo,iobuf,lr);
if(lw!=lr){
fprintf(stderr,"Error writing %u bytes to output file.  %u bytes reported written.\n",
lr,lw);
return 1;
}
nbytes+= lr;
if(!measure){
if(always_wait||(nts.tv_sec!=0)||(nts.tv_nsec> min_sleep_nsec)){
NANOSLEEP(&nts,&ntsrem);
}
}
nblocks++;

/*6:*/
#line 160 "valve.w"

if(!measure&&(nblocks>=secblocks)){
struct timeval tcblock;
double actime;

gettimeofday(&tcblock,&tz);
nnomsec++;
actime= (tcblock.tv_sec+(tcblock.tv_usec/1e6))-
(tstart.tv_sec+(tstart.tv_usec/1e6));


estsleep= estsleep/(transferRate/(nbytes/actime));

if(verbose){
fprintf(stderr,"Nominal time: %ld seconds.  Actual time: %.2f seconds."
"  Adjusted sleep interval %.0f\n",
nnomsec,actime,estsleep);
fprintf(stderr,"%s bytes transferred at %s bytes per second.\n",
commas((double)nbytes),commas(nbytes/actime));
}

nts.tv_sec= (time_t)(estsleep/1e9);
nts.tv_nsec= (long)(estsleep-nts.tv_sec);
nblocks= 0;
}

/*:6*/
#line 151 "valve.w"
;
}

/*:5*/
#line 90 "valve.w"
;

/*7:*/
#line 192 "valve.w"

if(showtrans){
gettimeofday(&tend,&tz);

duration= (tend.tv_sec+(tend.tv_usec/1e6))-
(tstart.tv_sec+(tstart.tv_usec/1e6));
fprintf(stderr,"%s bytes transferred at %s bytes per second.\n",
commas((double)nbytes),commas(nbytes/duration));
}


/*:7*/
#line 92 "valve.w"
;

return 0;
}

/*:3*/
#line 66 "valve.w"



/*:2*/
